/* 
  AgentManager.h

  Barry McMullin <mcmullin@eeng.dcu.ie>
  07-OCT-1996

*/

#import <objectbase/SwarmObject.h>
#import <simtools.h>

@interface AgentManager : SwarmObject {
  id agentClass;

  id agentList;
  id addedAgentQueue;
  id droppedAgentQueue;
  id uniformUnsigned;
}

-(void) setUniformUnsigned: (id) inUniformUnsigned;
-(id) getUniformUnsigned;
/* If you wish to use the method -randomAgent a
  uniformUnsigned distribution object (of the
  "variable" or non-"frozen" kind) must be available to
  the agentManager object.  This must be provided from
  outside via -setUniformUnsigned. This approach is
  preferred to having the agentManager object create
  its own private distribution object, because it will
  be quite common to create a uniformUnsigned
  distribution object for more general use in an app
  anyway, and share it around whoever else wants to use
  it...  */


-setAgentClass: (id) classId;
-createEnd;


-(id) getAgentList;
-(unsigned) getCount;

-(id) randomAgent;

-(id) createAgent;
-dropAgent: (id) agent;

-processQueues;

-saveTo: (id <OutFile>) file;
-loadFrom: (id <InFile>) file toLattice: (id) inLattice;

-(void) drop; // Overridden;

-(void) xprintStatus;  // Debug use only...

@end
