/* 
  Catalyst.h

  Barry McMullin <mcmullin@eeng.dcu.ie>
  30-SEP-1996


*/



#import "Particle.h"


@interface Catalyst : Particle {
  unsigned singlyBondedNeighborCount;
  unsigned doublyBondedNeighborCount;
}

// Overridden class methods (see doc in Particle.m)

+(void) setClassMobilityFactor: (double) inMobilityFactor;
+(double) getClassMobilityFactor;


// Additional Class methods.
+(void) setProductionProbability: (double) inProductionProbability;
+(double) getProductionProbability;
+(void) setCatalystDecayProbability: (double) inCatalystDecayProbability;
+(double) getCatalystDecayProbability;
+(void) setCatSmartMotionFlag: (BOOL) value;
+(BOOL) getCatSmartMotionFlag;

/* This Bernoulli distribution is used in implementing
   the random production reaction.  It must be a
   "variable" or non-"frozen" flavour of Bernoulli,
   created externally to the bonds; in this way a
   single bernoulli object can be shared around
   multiple usages in a single app.  */
+(void) setBernoulli: (id) inBernoulli; 
+(id) getBernoulli;

// Overridden instance method.
-step;
-(BOOL) canMoveToNeighborCode: (NeighborCode) neighborCode;

// Additional instance method.
-doProduction;


@end
