/* 
  PickNeighborCode.h

  This is used solely to create a "user interface"
  object for picking a NeighborCode value.  Use it by
  creating an instance of the class (it will create a
  probeDisplay on itself automatically); invoke
  -getNeighborCode; the user can use -next and
  -previous to cycle through the allowed NeighborCodes,
  -done when happy; when the user presses done,
  -getNeighborCode will return; the caller should then
  drop the PickNeighborCode object (and its
  probedisplay will go away too...).

  Barry McMullin <mcmullin@eeng.dcu.ie>
  MAR-1997 */

#import <objectbase/SwarmObject.h>

#import "NeighborCode.h"

@interface PickNeighborCode: SwarmObject {
  char *neighborCodeName;
  NeighborCode neighborCode;
  id lattice;
  BOOL done;
}

+create: (id) aZone withLattice: (id) inLattice;
-(NeighborCode) getNeighborCode;
-(void) nextCode;
-(void) previousCode;
-(id) continue;

@end
