/* 
  SCLModelSwarm.m

  Barry McMullin <mcmullin@eeng.dcu.ie>
  30-SEP-1996

*/

#import "SCLModelSwarm.h"

#import "SCLGlobals.h"
#import "VNneighborhood.h"
#import "MooreNeighborhood.h"
#import "SCLDisplay.h"
#import "AgentManager.h"
#import "ParticleManager.h"
#import "ParameterManager.h"
#import "WorldManager.h"
#import "UserCellEditor.h"
#import "Bond.h"

#import "Bond2.h"

#import "Hole.h"
#import "Substrate.h"
#import "Link.h"
#import "Link2.h"
#import "Catalyst.h"

@implementation SCLModelSwarm

-buildObjects {
  [super buildObjects];

  modelActionCache = actionCache;  
    // Cheeky, and probably dangerous!
  worldManager = [WorldManager create: [self getZone]];
  parameterManager = [ParameterManager create: [self getZone]];

  return self;
}


-step {
  [actionCache doTkEvents];
  [parameterManager slowdownKludge];
  [worldManager step];

  return self;
}

-buildActions {
  [super buildActions];
  
  modelActions = [ActionGroup create: [self getZone]];

  [modelActions createActionTo: self message: M(step)];

  modelSchedule = [Schedule createBegin: [self getZone]];
  [modelSchedule setRepeatInterval: 1];
  modelSchedule = [modelSchedule createEnd];
  [modelSchedule at: 0 createAction: modelActions];

  return self;
}

-activateIn: (id) swarmContext {
  [super activateIn: swarmContext];

  [modelSchedule activateIn: self];

  return [self getSwarmActivity];
}


-setStateStopped {
  /* 
    I don't simply use [controlPanel setStateStopped]
    because if we are already stopped that forces a wait
    for a click on some control panel button other than
    stop ... *not* what I want!
  */

  [controlPanel setState: ControlStateStopped];
  
  return self;
}


@end
