/* 
  WorldManager.h

  Barry McMullin <mcmullin@eeng.dcu.ie>
  17-OCT-1996

*/

#import <objectbase/SwarmObject.h>
#import <simtools.h>
#import <simtoolsgui.h>

@interface WorldManager : SwarmObject {
  id probeDisplay;

  int sbrkKByte;
  unsigned worldTime;
  unsigned repairMotionCount;
  unsigned displaceMotionCount;
  unsigned spliceCount;

  id prng;
  id bernoulli;
  id uniformUnsigned;
  id uniformDouble;

  unsigned modelTime;

  id worldDisplay;

  id world;
}

+createBegin: (id) aZone;
-createEnd;

-step;
-update;

-(id) kickPRNG;

-(unsigned) setWorldTime: (unsigned) time;
-(unsigned) getWorldTime;

-(void) setRepairMotionCount: (unsigned) inCount;
-(void) logRepairMotion;
-(void) setDisplaceMotionCount: (unsigned) inCount;
-(void) logDisplaceMotion;
-(void) setSpliceCount: (unsigned) inCount;
-(void) logSplice;

-dropWorld;
-createWorldWithX: (int) xSize Y: (int) ySize;
-createEmptyWorldWithX: (int) xSize Y: (int) ySize;
-createEmptyVNWorldWithX: (int) xSize Y: (int) ySize;
-createEmptyMooreWorldWithX: (int) xSize Y: (int) ySize;
-createEmptyFHPWorldWithX: (int) xSize Y: (int) ySize;
-createDefaultWorld;

-dropAgent: (id) agent;
-fillWithHoles;
-fillWithSubstrate;
-(int) adjustSubstrateNumberBy: (int) adjustment;
-(int) adjustLinkNumberBy: (int) adjustment;
-(int) adjustLink2NumberBy: (int) adjustment;
-(int) adjustCatalystNumberBy: (int) adjustment;

-refreshDisplay;

-saveToFileNamed: (char *) filename;
-loadFromFileNamed: (char *) filename;


@end
